---
title: Document.visibilityState
slug: Web/API/Document/visibilityState
tags:
  - DOM
  - Document
  - Page Visibility API
  - Property
  - Read-only
  - Reference
  - Web
---
<p>{{ ApiRef("DOM") }}</p>

<p><span class="seoSummary">The <strong><code>Document.visibilityState</code></strong> read-only property returns the visibility of the {{domxref('document')}}, that is in which context this element is now visible. It is useful to know if the document is in the background or an invisible tab, or only loaded for pre-rendering.</span> Possible values are:</p>

<dl>
 <dt><code>visible</code></dt>
 <dd>The page content may be at least partially visible. In practice this means that the page is the foreground tab of a non-minimized window.</dd>
 <dt><code>hidden</code></dt>
 <dd>The page content is not visible to the user. In practice this means that the document is either a background tab or part of a minimized window, or the OS screen lock is active.</dd>
 <dd>
 <div class="notecard warning">Safari doesn’t fire the <code><a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a></code> event as expected when <code>visibilityState</code> transitions to <code>hidden</code>; so for that case, you need to also include code to listen for the <code><a href="/en-US/docs/Web/API/Window/pagehide_event">pagehide</a></code> event.</div>
 </dd>
 <dt><code>prerender</code> {{deprecated_inline}}</dt>
 <dd>The page content is being prerendered and is not visible to the user (considered hidden for purposes of <code><a href="/en-US/docs/Web/API/Document/hidden">document.hidden</a></code>). The document may start in this state, but will never transition to it from another value. Note: This was removed from the standard. Check compatibility table for details.</dd>
</dl>

<p>When the value of this property changes, the {{domxref("Document/visibilitychange_event", "visibilitychange")}} event is sent to the {{domxref("Document")}}.</p>

<p>Typical use of this can be to prevent the download of some assets when the document is solely prerendered, or stop some activities when the document is in the background or minimized.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>string</var> = document.visibilityState</pre>

<h2 id="Examples">Examples</h2>

<pre class="brush:js; line-numbers  language-js notranslate">document.addEventListener("visibilitychange", function() {
  console.log( document.visibilityState );
  // Modify behavior...
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Page Visibility API','#visibility-states-and-the-visibilitystate-enum', 'Document.visibilityState')}}</td>
   <td>{{Spec2('Page Visibility API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.visibilityState")}}</p>
